import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { setTheme } from 'ngx-bootstrap/utils';
import { __extends, __decorate, __metadata, __awaiter, __generator, __read } from 'tslib';
import { Component, HostBinding, NgModule } from '@angular/core';
import { BaseUIComponent, ContainerProperties, propDescription, DataModelProperties, StyleProperties, getItemByIndex, CoreService, CoreModule } from '@ngx-dynamic-components/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var packageName = 'bootstrap';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ContainerComponent = /** @class */ (function (_super) {
    __extends(ContainerComponent, _super);
    function ContainerComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isContainer = true;
        _this.isFluidContainer = false;
        _this.height = 'auto';
        return _this;
    }
    /**
     * @return {?}
     */
    ContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.ngOnInit.call(this)];
                    case 1:
                        _a.sent();
                        if (this.properties.fullWidth) {
                            this.isFluidContainer = true;
                            this.isContainer = false;
                        }
                        if (this.properties.height) {
                            this.height = this.properties.height;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-container',
                    template: "\n    <dc-container-row *ngFor=\"let item of uiModel.children\" [ngStyle]=\"getStyles(item.itemProperties)\"\n      (changedDataModel)=\"changedDataModel.emit($event)\"\n      [uiModel]='item'\n      [dataModel]='dataModel'\n      [workflowEngine]='workflowEngine'\n    ></dc-container-row>\n  ",
                    styles: ["\n    :host {\n      display: block;\n    }\n  "]
                }] }
    ];
    ContainerComponent.propDecorators = {
        isContainer: [{ type: HostBinding, args: ['class.container',] }],
        isFluidContainer: [{ type: HostBinding, args: ['class.container-fluid',] }],
        height: [{ type: HostBinding, args: ['style.height',] }]
    };
    return ContainerComponent;
}(BaseUIComponent));
var BSContainerProperties = /** @class */ (function (_super) {
    __extends(BSContainerProperties, _super);
    function BSContainerProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Is full width container, default false',
            example: 'true',
        }),
        __metadata("design:type", Boolean)
    ], BSContainerProperties.prototype, "fullWidth", void 0);
    return BSContainerProperties;
}(ContainerProperties));
/** @type {?} */
var example = {
    title: 'Bootstrap container example',
    uiModel: {
        type: 'bootstrap:container',
        containerProperties: {
            width: '100%'
        },
        itemProperties: {
            width: '20%',
            padding: '10px'
        },
        children: [{
                type: 'bootstrap:bs-row',
                children: [{
                        type: 'bootstrap:text-input',
                        containerProperties: {},
                        itemProperties: {
                            label: 'Input-1',
                            placeholder: 'Name first section',
                            dataModelPath: '$.first'
                        }
                    }, {
                        type: 'bootstrap:text-input',
                        containerProperties: {},
                        itemProperties: {
                            label: 'Input-2',
                            placeholder: 'Name second section',
                            dataModelPath: '$.second'
                        }
                    }]
            }, {
                type: 'bootstrap:bs-row',
                children: [{
                        type: 'bootstrap:text-input',
                        containerProperties: {},
                        itemProperties: {
                            label: 'Input-11',
                            placeholder: 'Name third section',
                            dataModelPath: '$.third'
                        }
                    }, {
                        type: 'bootstrap:text-input',
                        containerProperties: {},
                        itemProperties: {
                            label: 'Input-22',
                            placeholder: 'Name fourth section',
                            dataModelPath: '$.forth'
                        }
                    }]
            }]
    },
    dataModel: {}
};
/** @type {?} */
var containerDescriptor = {
    name: 'container',
    packageName: packageName,
    category: "Layout" /* Layout */,
    description: 'Bootstrap container',
    itemProperties: BSContainerProperties,
    component: ContainerComponent,
    example: example
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ContainerRowComponent = /** @class */ (function (_super) {
    __extends(ContainerRowComponent, _super);
    function ContainerRowComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isRow = true;
        _this.isColumn = false;
        return _this;
    }
    /**
     * @return {?}
     */
    ContainerRowComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.ngOnInit.call(this)];
                    case 1:
                        _a.sent();
                        this.isColumn = this.properties && this.properties.direction === 'column';
                        return [2 /*return*/];
                }
            });
        });
    };
    ContainerRowComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-container-row',
                    template: "\n    <div *ngFor=\"let item of uiModel.children\" class=\"col\" [ngStyle]=\"getStyles(item.containerProperties)\"\n      [ngClass]=\"item.containerProperties?.bsClasses\">\n      <dc-ui-selector\n          (changedDataModel)=\"changedDataModel.emit($event)\"\n          [uiModel]='item'\n          [dataModel]='dataModel'\n          [workflowEngine]='workflowEngine'\n      ></dc-ui-selector>\n    </div>\n  "
                }] }
    ];
    ContainerRowComponent.propDecorators = {
        isRow: [{ type: HostBinding, args: ['class.row',] }],
        isColumn: [{ type: HostBinding, args: ['class.flex-column',] }]
    };
    return ContainerRowComponent;
}(BaseUIComponent));
var BSContainerRowProperties = /** @class */ (function (_super) {
    __extends(BSContainerRowProperties, _super);
    function BSContainerRowProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Bootstrap row child classes',
            example: 'col-9'
        }),
        __metadata("design:type", Array)
    ], BSContainerRowProperties.prototype, "bsClasses", void 0);
    __decorate([
        propDescription({
            description: 'Flex direction',
            example: 'column'
        }),
        __metadata("design:type", String)
    ], BSContainerRowProperties.prototype, "direction", void 0);
    return BSContainerRowProperties;
}(ContainerProperties));
/** @type {?} */
var example$1 = {
    title: 'Bootstrap container row example',
    uiModel: {
        type: 'bootstrap:bs-row',
        containerProperties: {
            width: '100%'
        },
        itemProperties: {
            width: '50%',
            padding: '10px'
        },
        children: [{
                type: 'bootstrap:text-input',
                containerProperties: {},
                itemProperties: {
                    label: 'Input-1',
                    placeholder: 'Name first section',
                    dataModelPath: '$.first'
                }
            }, {
                type: 'bootstrap:text-input',
                containerProperties: {},
                itemProperties: {
                    label: 'Input2',
                    placeholder: 'Name second section',
                    dataModelPath: '$.second'
                }
            }]
    },
    dataModel: {}
};
/** @type {?} */
var containerRowDescriptor = {
    name: 'bs-row',
    packageName: 'bootstrap',
    category: 'Layout',
    description: 'Bootstrap row container',
    itemProperties: BSContainerRowProperties,
    component: ContainerRowComponent,
    example: example$1
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var InputUIComponent = /** @class */ (function (_super) {
    __extends(InputUIComponent, _super);
    function InputUIComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(InputUIComponent.prototype, "id", {
        get: /**
         * @return {?}
         */
        function () {
            return 'input-id-' + this.properties.label.replace(/ /g, '-').toLowerCase();
        },
        enumerable: true,
        configurable: true
    });
    InputUIComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-input-ui',
                    template: "\n  <div class=\"form-group\" [ngStyle]=\"containerStyles\">\n    <ng-container *ngIf=\"properties.label; else noLabel\">\n      <label [for]=\"id\">{{properties.label}}</label>\n      <input [id]=\"id\" [type]=\"properties.type || 'text'\" class=\"form-control\"\n        [placeholder]=\"properties.placeholder\"\n        [ngStyle]=\"itemStyles\"\n        (input)=\"changedDataModel.emit(this.dataModel)\"\n        [(ngModel)]=\"componentDataModel\">\n    </ng-container>\n    <ng-template #noLabel>\n      <input [type]=\"properties.type || 'text'\" class=\"form-control\"\n        [placeholder]=\"properties.placeholder\"\n        [ngStyle]=\"itemStyles\"\n        (input)=\"changedDataModel.emit(this.dataModel)\"\n        [(ngModel)]=\"componentDataModel\">\n    </ng-template>\n  </div>\n  "
                }] }
    ];
    return InputUIComponent;
}(BaseUIComponent));
var InputProperties = /** @class */ (function (_super) {
    __extends(InputProperties, _super);
    function InputProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Text shown when field is empty',
            example: 'Type your name',
        }),
        __metadata("design:type", String)
    ], InputProperties.prototype, "placeholder", void 0);
    return InputProperties;
}(DataModelProperties));
/** @type {?} */
var example$2 = {
    title: 'Text input example',
    uiModel: {
        type: packageName + ":text-input",
        containerProperties: {},
        itemProperties: {
            label: 'Name',
            placeholder: 'Enter your name',
            dataModelPath: '$.name'
        }
    },
    dataModel: {}
};
/** @type {?} */
var inputDescriptor = {
    name: 'text-input',
    packageName: packageName,
    category: "Form control" /* FormControl */,
    description: 'Input component',
    itemProperties: InputProperties,
    component: InputUIComponent,
    example: example$2
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SelectUIComponent = /** @class */ (function (_super) {
    __extends(SelectUIComponent, _super);
    function SelectUIComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    SelectUIComponent.prototype.onSelect = /**
     * @return {?}
     */
    function () {
        this.changedDataModel.emit(this.dataModel);
        this.triggerAction('_selectionChanged');
    };
    Object.defineProperty(SelectUIComponent.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var options = this.properties.options;
            return options && options.length ? null : 'disabled';
        },
        enumerable: true,
        configurable: true
    });
    SelectUIComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-select-ui',
                    template: "\n    <div class=\"form-group\" [ngStyle]=\"containerStyles\">\n      <label *ngIf=\"properties.label\" selected>{{properties.label}}</label>\n      <select class=\"form-control\" [ngStyle]=\"itemStyles\"\n        (change)=\"onSelect()\"\n        [(ngModel)]=\"componentDataModel\" [attr.disabled]=\"disabled\">\n        <option *ngFor=\"let option of properties.options\" [value]=\"option.value\">{{option.label}}</option>\n      </select>\n    </div>\n  "
                }] }
    ];
    return SelectUIComponent;
}(BaseUIComponent));
var SelectProperties = /** @class */ (function (_super) {
    __extends(SelectProperties, _super);
    function SelectProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Select options.',
            example: '[{label: "One", value: 1}]',
        }),
        __metadata("design:type", Array)
    ], SelectProperties.prototype, "options", void 0);
    __decorate([
        propDescription({
            description: 'Label shown when no option is selected.',
            example: 'Please select an option',
        }),
        __metadata("design:type", String)
    ], SelectProperties.prototype, "label", void 0);
    return SelectProperties;
}(DataModelProperties));
/** @type {?} */
var example$3 = {
    uiModel: {
        type: packageName + ":select",
        containerProperties: {},
        id: 'stateSelection',
        itemProperties: {
            options: [
                { label: 'United Kingdom', value: 'uk' },
                { label: 'Ukraine', value: 'ua' }
            ],
            label: 'Country',
            dataModelPath: '$.country'
        }
    },
    dataModel: {},
    title: 'Basic select example'
};
/** @type {?} */
var selectDescriptor = {
    name: 'select',
    packageName: packageName,
    category: "Form control" /* FormControl */,
    description: 'Select component',
    itemProperties: SelectProperties,
    component: SelectUIComponent,
    example: example$3
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CheckboxUIComponent = /** @class */ (function (_super) {
    __extends(CheckboxUIComponent, _super);
    function CheckboxUIComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CheckboxUIComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-checkbox-ui',
                    template: "\n    <div class=\"form-check\" [ngClass]=\"{'form-check-inline': properties.inline}\" [ngStyle]=\"containerStyles\">\n      <input class=\"form-check-input\" type=\"checkbox\"\n      [ngStyle]=\"itemStyles\"\n      (change)=\"changedDataModel.emit(this.dataModel)\"\n      [(ngModel)]=\"componentDataModel\">\n      <label *ngIf=\"properties.label\" class=\"form-check-label\">{{properties.label}}</label>\n    </div>\n  "
                }] }
    ];
    return CheckboxUIComponent;
}(BaseUIComponent));
var CheckboxProperties = /** @class */ (function (_super) {
    __extends(CheckboxProperties, _super);
    function CheckboxProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Label',
            example: 'Accept conditions.',
        }),
        __metadata("design:type", String)
    ], CheckboxProperties.prototype, "label", void 0);
    __decorate([
        propDescription({
            description: 'Inline',
            example: 'true',
        }),
        __metadata("design:type", Boolean)
    ], CheckboxProperties.prototype, "inline", void 0);
    return CheckboxProperties;
}(DataModelProperties));
/** @type {?} */
var example$4 = {
    title: 'Checkbox example',
    uiModel: {
        type: packageName + ":checkbox",
        containerProperties: {},
        itemProperties: {
            label: 'Accept conditions',
            padding: '10px',
            margin: '20px',
            dataModelPath: '$.accept',
            inline: true
        }
    },
    dataModel: {}
};
/** @type {?} */
var checkboxDescriptor = {
    name: 'checkbox',
    packageName: packageName,
    category: "Form control" /* FormControl */,
    description: 'Checkbox component',
    itemProperties: CheckboxProperties,
    component: CheckboxUIComponent,
    example: example$4
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RadioGroupUIComponent = /** @class */ (function (_super) {
    __extends(RadioGroupUIComponent, _super);
    function RadioGroupUIComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} option
     * @return {?}
     */
    RadioGroupUIComponent.prototype.onChange = /**
     * @param {?} option
     * @return {?}
     */
    function (option) {
        this.componentDataModel = option.value;
        this.changedDataModel.emit(this.dataModel);
    };
    RadioGroupUIComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-radio-group-ui',
                    template: "\n    <div class=\"form-check\" *ngFor=\"let option of properties.options\"\n      [ngClass]=\"{'form-check-inline': properties.inline}\" [ngStyle]=\"itemStyles\">\n      <input class=\"form-check-input\" type=\"radio\"\n      (change)=\"onChange(option)\"\n      [name]=\"properties.dataModelPath\" [value]=\"option.value\">\n      <label class=\"form-check-label\">{{option.label}}</label>\n    </div>\n  "
                }] }
    ];
    return RadioGroupUIComponent;
}(BaseUIComponent));
var RadioGroupProperties = /** @class */ (function (_super) {
    __extends(RadioGroupProperties, _super);
    function RadioGroupProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Label',
            example: 'Select color',
        }),
        __metadata("design:type", String)
    ], RadioGroupProperties.prototype, "label", void 0);
    __decorate([
        propDescription({
            description: 'Radio group options',
            example: '[{label: "One", value: 1}]',
        }),
        __metadata("design:type", Array)
    ], RadioGroupProperties.prototype, "options", void 0);
    __decorate([
        propDescription({
            description: 'Radio options inline',
            example: 'true',
        }),
        __metadata("design:type", String)
    ], RadioGroupProperties.prototype, "inline", void 0);
    return RadioGroupProperties;
}(DataModelProperties));
/** @type {?} */
var example$5 = {
    title: 'Radio group example',
    uiModel: {
        type: packageName + ":radio-group",
        containerProperties: {},
        itemProperties: {
            label: 'Select color',
            padding: '5px 20px',
            margin: '10px 0',
            dataModelPath: '$.color',
            options: [{ label: 'White', value: 'white' }, { label: 'Black', value: 'black' }],
        }
    },
    dataModel: {}
};
/** @type {?} */
var radioGroupDescriptor = {
    name: 'radio-group',
    packageName: packageName,
    category: "Form control" /* FormControl */,
    description: 'Radio group component',
    itemProperties: RadioGroupProperties,
    component: RadioGroupUIComponent,
    example: example$5
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TextareaUIComponent = /** @class */ (function (_super) {
    __extends(TextareaUIComponent, _super);
    function TextareaUIComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TextareaUIComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-textarea-ui',
                    template: "\n    <div class=\"form-group\" [ngStyle]=\"itemStyles\">\n      <label *ngIf=\"properties.label\">{{properties.label}}</label>\n      <textarea class=\"form-control\"\n        [rows]=\"properties.rows\"\n        [placeholder]=\"properties.placeholder\"\n        [ngStyle]=\"itemStyles\"\n        (input)=\"changedDataModel.emit(this.dataModel)\"\n        [(ngModel)]=\"componentDataModel\"></textarea>\n    </div>\n  "
                }] }
    ];
    return TextareaUIComponent;
}(BaseUIComponent));
var TextareaProperties = /** @class */ (function (_super) {
    __extends(TextareaProperties, _super);
    function TextareaProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Number of rows in textarea',
            example: '5',
        }),
        __metadata("design:type", Number)
    ], TextareaProperties.prototype, "rows", void 0);
    __decorate([
        propDescription({
            description: 'Text shown when field is empty',
            example: 'Type about yourself',
        }),
        __metadata("design:type", String)
    ], TextareaProperties.prototype, "placeholder", void 0);
    __decorate([
        propDescription({
            description: 'Text area label',
            example: 'Type about yourself',
        }),
        __metadata("design:type", String)
    ], TextareaProperties.prototype, "label", void 0);
    return TextareaProperties;
}(DataModelProperties));
/** @type {?} */
var example$6 = {
    title: 'Text area example',
    uiModel: {
        type: packageName + ":textarea",
        containerProperties: {},
        itemProperties: {
            rows: 10,
            placeholder: 'Type information about yourself',
            dataModelPath: '$.info'
        }
    },
    dataModel: {}
};
/** @type {?} */
var textareaDescriptor = {
    name: 'textarea',
    packageName: packageName,
    category: "Form control" /* FormControl */,
    description: 'Text area component',
    itemProperties: TextareaProperties,
    component: TextareaUIComponent,
    example: example$6
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ButtonUIComponent = /** @class */ (function (_super) {
    __extends(ButtonUIComponent, _super);
    function ButtonUIComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    ButtonUIComponent.prototype.onClick = /**
     * @return {?}
     */
    function () {
        this.workflowEngine.run(this.properties.clickActionKey);
        this.changedDataModel.emit(this.dataModel);
    };
    ButtonUIComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-button-ui',
                    template: "\n    <button class=\"btn \" [ngClass]=\"properties.btnClass || 'btn-primary'\"\n      [type]=\"properties.type\" [ngStyle]=\"itemStyles\"\n      (click)=\"onClick()\">{{properties.label}}</button>\n  "
                }] }
    ];
    return ButtonUIComponent;
}(BaseUIComponent));
var ButtonProperties = /** @class */ (function (_super) {
    __extends(ButtonProperties, _super);
    function ButtonProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Button label',
            example: 'Click me!',
        }),
        __metadata("design:type", String)
    ], ButtonProperties.prototype, "label", void 0);
    __decorate([
        propDescription({
            description: 'Key for action that fires onclick',
            example: 'submit',
        }),
        __metadata("design:type", String)
    ], ButtonProperties.prototype, "clickActionKey", void 0);
    __decorate([
        propDescription({
            description: 'Bootstrap predefined button class',
            example: 'btn-secondary',
        }),
        __metadata("design:type", String)
    ], ButtonProperties.prototype, "btnClass", void 0);
    __decorate([
        propDescription({
            description: 'Button type: button|submit|reset. Default: button',
            example: 'submit',
        }),
        __metadata("design:type", String)
    ], ButtonProperties.prototype, "type", void 0);
    return ButtonProperties;
}(StyleProperties));
/** @type {?} */
var example$7 = {
    title: 'Basic button example',
    uiModel: {
        type: packageName + ":button",
        containerProperties: {},
        itemProperties: {
            label: 'SUBMIT',
            width: '50%',
            margin: '15px',
            padding: '10px 5px 10px 0px',
            clickActionKey: 'consoleLog'
        }
    },
    dataModel: {}
};
/** @type {?} */
var buttonDescriptor = {
    name: 'button',
    packageName: packageName,
    category: "Buttons" /* Buttons */,
    description: 'Button component',
    itemProperties: ButtonProperties,
    component: ButtonUIComponent,
    example: example$7
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardComponent = /** @class */ (function (_super) {
    __extends(CardComponent, _super);
    function CardComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(CardComponent.prototype, "header", {
        get: /**
         * @return {?}
         */
        function () {
            return this.getChildByIndex(0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CardComponent.prototype, "content", {
        get: /**
         * @return {?}
         */
        function () {
            return this.getChildByIndex(1);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CardComponent.prototype, "footer", {
        get: /**
         * @return {?}
         */
        function () {
            return this.getChildByIndex(2);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @param {?} index
     * @return {?}
     */
    CardComponent.prototype.getChildByIndex = /**
     * @private
     * @param {?} index
     * @return {?}
     */
    function (index) {
        return getItemByIndex(this.uiModel.children, index);
    };
    CardComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-card',
                    template: "\n  <div class=\"card\">\n    <div class=\"card-header\" *ngIf=\"header\">\n      <dc-ui-selector\n        (changedDataModel)=\"changedDataModel.emit(this.dataModel)\"\n        [uiModel]='header'\n        [dataModel]='dataModel'\n        [workflowEngine]='workflowEngine'></dc-ui-selector>\n    </div>\n    <div class=\"card-body\" *ngIf=\"content\">\n      <dc-ui-selector\n        (changedDataModel)=\"changedDataModel.emit(this.dataModel)\"\n        [uiModel]='content'\n        [dataModel]='dataModel'\n        [workflowEngine]='workflowEngine'></dc-ui-selector>\n    </div>\n    <div class=\"card-footer\" *ngIf=\"footer\">\n      <dc-ui-selector\n        (changedDataModel)=\"changedDataModel.emit(this.dataModel)\"\n        [uiModel]='footer'\n        [dataModel]='dataModel'\n        [workflowEngine]='workflowEngine'></dc-ui-selector>\n    </div>\n  </div>"
                }] }
    ];
    return CardComponent;
}(BaseUIComponent));
var CardProperties = /** @class */ (function (_super) {
    __extends(CardProperties, _super);
    function CardProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Card can have 3 children, 1 - header, 2 - content, 3 - footer.',
            example: "[null, {\n      type: 'material:text',\n      containerProperties: {},\n      itemProperties: {\n        text: 'Card content text',\n      }\n    }, null]",
        }),
        __metadata("design:type", Array)
    ], CardProperties.prototype, "children", void 0);
    return CardProperties;
}(ContainerProperties));
/** @type {?} */
var example$8 = {
    title: 'Card panel example',
    uiModel: {
        type: 'bootstrap:card',
        containerProperties: {},
        itemProperties: {
            padding: '10px',
            margin: '10px auto',
            width: '80%'
        },
        children: [{
                type: 'material:text',
                containerProperties: {},
                itemProperties: {
                    text: 'Card header text',
                    width: '100%'
                }
            }, {
                type: 'material:textarea',
                containerProperties: {
                    width: '100%',
                },
                itemProperties: {
                    rows: 4,
                    placeholder: 'Type card information',
                    dataModelPath: '$.card/info'
                }
            }, {
                type: 'bootstrap:button',
                containerProperties: {},
                itemProperties: {
                    label: 'Submit',
                    margin: '16px',
                    width: '50%',
                    clickActionKey: 'consoleLog'
                }
            }]
    },
    dataModel: {}
};
/** @type {?} */
var cardDescriptor = {
    name: 'card',
    packageName: packageName,
    category: "Layout" /* Layout */,
    description: 'Card layout component',
    itemProperties: CardProperties,
    component: CardComponent,
    example: example$8
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var COMPONENTS_LIST = [
    containerDescriptor,
    containerRowDescriptor,
    inputDescriptor,
    selectDescriptor,
    checkboxDescriptor,
    radioGroupDescriptor,
    textareaDescriptor,
    buttonDescriptor,
    cardDescriptor
];
// Register components.
/**
 * @return {?}
 */
function registerComponents() {
    COMPONENTS_LIST.forEach((/**
     * @param {?} component
     * @return {?}
     */
    function (component) { return CoreService.registerComponent(component); }));
}
/**
 * @return {?}
 */
function getCategories() {
    /** @type {?} */
    var categories = COMPONENTS_LIST.reduce((/**
     * @param {?} map
     * @param {?} desc
     * @return {?}
     */
    function (map, desc) {
        map[desc.category] = map[desc.category] || [];
        map[desc.category].push(desc);
        return map;
    }), {});
    return Object.entries(categories).map((/**
     * @param {?} __0
     * @return {?}
     */
    function (_a) {
        var _b = __read(_a, 2), key = _b[0], val = _b[1];
        return {
            name: key,
            components: val,
            packageName: packageName
        };
    }));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapModule = /** @class */ (function () {
    function BootstrapModule() {
        setTheme('bs4');
        registerComponents();
    }
    BootstrapModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ContainerComponent, ContainerRowComponent, InputUIComponent, SelectUIComponent,
                        CheckboxUIComponent, RadioGroupUIComponent, TextareaUIComponent, ButtonUIComponent, CardComponent],
                    imports: [
                        CoreModule,
                        CommonModule,
                        FormsModule
                    ],
                    exports: [ContainerComponent, ContainerRowComponent, InputUIComponent],
                    entryComponents: [ContainerComponent, ContainerRowComponent, InputUIComponent, SelectUIComponent,
                        CheckboxUIComponent, RadioGroupUIComponent, TextareaUIComponent, ButtonUIComponent, CardComponent]
                },] }
    ];
    /** @nocollapse */
    BootstrapModule.ctorParameters = function () { return []; };
    return BootstrapModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { COMPONENTS_LIST, getCategories, BootstrapModule, ButtonProperties as ɵbd, ButtonUIComponent as ɵbc, buttonDescriptor as ɵbf, example$7 as ɵbe, CardComponent as ɵbg, CardProperties as ɵbh, cardDescriptor as ɵbi, CheckboxProperties as ɵr, CheckboxUIComponent as ɵq, checkboxDescriptor as ɵt, example$4 as ɵs, BSContainerRowProperties as ɵf, ContainerRowComponent as ɵe, containerRowDescriptor as ɵh, example$1 as ɵg, BSContainerProperties as ɵb, ContainerComponent as ɵa, containerDescriptor as ɵd, example as ɵc, InputProperties as ɵj, InputUIComponent as ɵi, example$2 as ɵk, inputDescriptor as ɵl, RadioGroupProperties as ɵv, RadioGroupUIComponent as ɵu, example$5 as ɵw, radioGroupDescriptor as ɵx, SelectProperties as ɵn, SelectUIComponent as ɵm, example$3 as ɵo, selectDescriptor as ɵp, TextareaProperties as ɵz, TextareaUIComponent as ɵy, example$6 as ɵba, textareaDescriptor as ɵbb, packageName as ɵbj };

//# sourceMappingURL=ngx-dynamic-components-bootstrap.js.map